/*
 * DTE.h
 *
 * Author: Neta Yahav, Pavel Brychta
 */

#pragma once

#include <Arduino.h>

class DTE {
  public:
    enum CommandResult {
        EXPECT_BUSY,
        EXPECT_TIMEOUT,
        EXPECT_DELAY,
        EXPECT_RESULT
    };

  protected:
    String buffer;
    Stream & stream;
    unsigned int bufferSize;
    String response[3];
    unsigned long timeout;
    unsigned long tick;
    unsigned int match;
    CommandResult result;

  public:
    DTE(Stream & stream, unsigned int size);

    ~DTE() = default;

    void SendCommand(const char * command, unsigned long timeout, const char * response1, const char * response2 = nullptr, const char * response3 = nullptr);

    void SendCommand(const __FlashStringHelper * command, unsigned long timeout, const char * response1, const char * response2 = nullptr, const char * response3 = nullptr);

    void Delay(unsigned long delay);

    bool getIsBusy();

    CommandResult getResult();

    [[nodiscard]] unsigned int getMatch() const;

    String & getBuffer();

  protected:
    void flush();

    void process();
}; // DTE
